<div
  class="container-background-color container-border-color grouped-multi-list p-2 overflow-hidden flex-column flex-grow-shrink"
  [style.width]="width + 'px'"
  [style.max-height]="height + 'px'"
  [style.box-shadow]="showDropShadow ? boxShadow : null"
  [sqtmCoreWorkspace]="workspace"
  [localTheme]="true"
>
  <ng-content select="[projection=customMenu]"></ng-content>

  @if (searchable) {
    <div
      class="p-8 flex-fixed-size"
      [attr.data-test-element-id]="'search-field'"
    >
      <nz-input-group [nzSuffix]="suffixIconSearch">
        <input
          type="text"
          #input
          nz-input
          [(ngModel)]="researchValue"
          (keyup)="handleKeyboardInput()"
          [attr.data-test-element-id]="'input-filter'"
        />
      </nz-input-group>
      <div class="spacer"></div>
    </div>
  }

  @if (displayToggleAllItemsCheckbox) {
    <div
      class="p-4 m-l-8 __hover_pointer __hover_background_color txt-ellipsis flex-row item-row"
      style="min-height: 25px"
    >
      <sqtm-core-simple-checkbox
        class="flex-fixed-size"
        style="width: 14px"
        (clickedInActiveMode)="toggleAllItems()"
        [nz-tooltip]="
          toggleAllItemValue
            ? ('sqtm-core.generic.label.unselect-all' | translate)
            : ('sqtm-core.generic.label.select-all' | translate)
        "
        [value]="toggleAllItemValue"
      >
      </sqtm-core-simple-checkbox>
    </div>
    <div class="spacer"></div>
  }

  @if (filteredItems.length > 0) {
    @if (hasSelectItemsToShow) {
      <div
        class="full-height full-width"
        [attr.data-test-element-id]="'selected-items'"
        [style.min-height]="minSelectedItemsHeight + 'px'"
        style="overflow-y: auto"
      >
        <ng-container
          *ngTemplateOutlet="
            itemsTemplate;
            context: { items: selectedItemsToDisplay }
          "
        ></ng-container>
      </div>
    }
    @if (hasSelectItemsToShow) {
      <div class="flex-fixed-size spacer"></div>
    }
    <!--  Items without virtual scroll-->
    @if (!virtualScroll) {
      <div
        class="full-height full-width"
        style="overflow-y: auto"
        [style.min-height]="minAvailableItemsHeight + 'px'"
      >
        <div [attr.data-test-element-id]="'ungrouped-items'">
          <ng-container
            *ngTemplateOutlet="
              itemsTemplate;
              context: { items: filteredUngroupedItems }
            "
          ></ng-container>
        </div>
        @for (group of filteredGroupDisplay; track group) {
          <div class="m-t-4" [attr.data-test-element-id]="'group'">
            <div
              class="m-l-8 label-color"
              [attr.data-test-element-id]="'group-label'"
            >
              {{ group.label | capitalize }}
            </div>
            <ng-container
              *ngTemplateOutlet="itemsTemplate; context: { items: group.items }"
            ></ng-container>
          </div>
        }
      </div>
    }
    <!--  Items with virtual scroll-->
    @if (virtualScroll) {
      <ng-container
        *ngTemplateOutlet="
          itemVirtualScrollTemplate;
          context: {
            items: filteredUngroupedItems,
            componentId: 'ungrouped-items',
            minHeight: minAvailableItemsHeight
          }
        "
      ></ng-container>
    }
    <div class="flex-fixed-size" [attr.data-test-element-id]="'operation'">
      <!--  Content projection for operation selector or other addition to the widget-->
      <ng-content></ng-content>
    </div>
  } @else {
    <div class="flex-row placeholder">
      {{ 'sqtm-core.grid.empty-grid.label' | translate }}
    </div>
  }
</div>

<ng-template #suffixIconSearch>
  <i nz-icon nzType="search"></i>
</ng-template>

<ng-template #itemsTemplate let-items="items">
  @for (item of items; track trackItemById($index, item)) {
    <div
      class="p-4 __hover_pointer __hover_background_color txt-ellipsis flex-row item-row"
      [style.height]="rowHeight + 'px'"
      [attr.data-test-element-id]="'item'"
      (click)="toggleItem(item.id)"
    >
      <sqtm-core-simple-checkbox
        class="flex-fixed-size m-l-8"
        [value]="item.selected"
      ></sqtm-core-simple-checkbox>
      <ng-container
        *ngTemplateOutlet="
          item.customTemplate || defaultItemTemplate;
          context: { item: item }
        "
      ></ng-container>
    </div>
  }
</ng-template>

<ng-template
  #itemVirtualScrollTemplate
  let-items="items"
  let-componentId="componentId"
  let-minHeight="minHeight"
>
  <cdk-virtual-scroll-viewport
    [itemSize]="rowHeight"
    [style.min-height]="minHeight + 'px'"
    [attr.data-test-element-id]="componentId"
    class="full-height full-width cdk-virtual-scroll-max-with-override"
  >
    <div
      class="p-4 __hover_pointer __hover_background_color txt-ellipsis flex-row full-width item-row"
      *cdkVirtualFor="let item of items; trackBy: trackItemById"
      [style.height]="rowHeight + 'px'"
      [attr.data-test-element-id]="'item'"
      (click)="toggleItem(item.id)"
    >
      <sqtm-core-simple-checkbox
        class="flex-fixed-size m-l-8"
        [value]="item.selected"
      ></sqtm-core-simple-checkbox>
      <ng-container
        *ngTemplateOutlet="
          item.customTemplate || defaultItemTemplate;
          context: { item: item }
        "
      ></ng-container>
    </div>
  </cdk-virtual-scroll-viewport>
</ng-template>

<ng-template #defaultItemTemplate let-item="item">
  <span
    class="m-l-5 txt-ellipsis"
    nz-tooltip
    [sqtmCoreLabelTooltip]="item.label"
    >{{ item.label }}</span
  >
</ng-template>
